/**
 * @author v_wangyan
 * @date 2012-09-13
 */ 
function g(element) { 
	return document.getElementById(element) || element;
}	
function jsonDecode(jsonString) {
	return (new Function("return " + jsonString))();
}
function show(id) {
	isShow(id, true);
}
function hide(id) {
	isShow(id, false);
}
function isShow(id, flag) {
	g(id).style.display = flag ? 'block' : 'none';
}
function addClass(element, className) { 
	element = g(element)||element;
    var classArray = className.split(/\s+/),
        result = element.className,
        classMatch = " " + result + " ",
        i = 0,
        l = classArray.length;

    for (; i < l; i++) {
         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {
             result += (result ? ' ' : '') + classArray[i];
         }
    }

    element.className = result;
}
function removeClass(element, className) { 
	element = g(element)||element; 

    var oldClasses = element.className.split(/\s+/),
        newClasses = className.split(/\s+/),
        lenOld,
        lenDel = newClasses.length,
        j,
        i = 0;  
    for (; i < lenDel; ++i) {
        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {
            if (oldClasses[j] == newClasses[i]) {
            	oldClasses.splice(j, 1);
            	break;
            }
        }
    }
    element.className = oldClasses.join(' ');
}
/**
 * 创建dom对象
 * @param  {string} tagName   要创建的dom名称
 * @param  {string} className 样式名
 * @return {void}           无
 */
function createElement (tagName, className) {
  var div = document.createElement(tagName);
  div.className = className;
  return div;
}
/**
 * 阻止冒泡事件
 * @param {event} 事件对象
 * @return void
 */
function cancelBubble(e){     
  if (e.stopPropagation) e.stopPropagation();
  else e.cancelBubble = true;
}
/**
 * 清除空格
 * @param {string} 目标字符串
 * @return string
 */
function trim(str){   
    return str.replace(/^(\s|\u00A0)+/,'').replace(/(\s|\u00A0)+$/,'');   
} 
/**
 * 执行命令
 * @param {string} 命令名称
 * @param {string} 值
 * @return string | void
 */
function execOrder(order, key) {
    var info = '';
    try { 
        key = (key.length == 0 ? '0' : key); 
        info = window.external.SyncRequest(order, key);
    } catch (e) {       
    } 
    return info;
}
/**
 * 设置字体
 * @param {int}   
 * @return void
 */
function setFontFamily(key) {   //设置字体:  0-宋体 ; 1-微软雅黑;
    key = key || '0';
    var obj = document.body;
    var font = '';
    if (key) {
        font = '"微软雅黑", "宋体", Arial, Verdana';
    } else {
        font = '"宋体", "微软雅黑", Arial, Verdana';
    }
    obj.style.fontFamily = font;
}
/**
 * 设置页面显示的字体(win7--雅黑字,其他为宋体)
 * @param 无
 * @return string
 */
function getSysver() {
    var key = 0;
    try {
        key = execOrder('sysver');
        if ('6.1' == key) {
            key = 1;
        }
    } catch (e) {   }   
    
    setFontFamily(key); 
}
// 供客户端调用
function setButtonState(key, statu) { 
    var status = rabbit.buttonstatus;
    var id = '';
    key = key || '0';
    id = status[key].id;
    statu =  statu || (g(id).getAttribute('statu') == '0' ? '1' : '0');     
    g(id).style.backgroundImage = 'url(images/icons/' + status[key][statu] + ')';
    g(id).setAttribute ('statu', statu);        
}
/**
 * 处理icon点击
 * @param  {event} e          事件
 * @param  {bool} rightClick 是否为右键(点击)
 * @param  {number} key        iconid
 * @return {void}            无
 */
function execMouseDown(e, rightClick, key) {
    //取消冒泡事件
    e.stopPropagation(); 
    
    var order = rightClick ? 'mouseRDown' : 'mouseLDown';
    try {
        window.external.SyncRequest(order, key);
    } catch (e) {}  
}
/**
 * 初始输入法状态  
 * 参数:0 (中英文切换) 返回值: 0 英文 1 中文;
 * 参数:1 (全半角切换) 返回值: 0 半角 1 全角; 
 * 参数:2 (中英文标点) 返回值: 0 英文标点 1 中文标点;
 * 参数:3 (软键盘)
 * 参数:4 (登录)            返回值: 0 未登录 1 已登录
 * 参数:5 (配置)
 */
function setIMEStatus() {
    setButtonState('0', getExecStatus('language', '0'));    
    setButtonState('1', getExecStatus('characters', '1'));  
    setButtonState('2', getExecStatus('punctuation', '2')); 
    setButtonState('4', getExecStatus('login', '4'));   
}
//获取RD数据status,null 时返回当前状态
/**
 * 设置icon状态
 * @param  {string} id  icon的id
 * @param  {string} key 命令
 * @return {void}     无
 */
function getExecStatus(id, key) { 
    var statu = execSync('getButtonState', key) || g(id).getAttribute('statu'); 
    return statu;
}
/**
 * 处理右键点击
 * @param  {string} id elementid
 * @return {void}    无
 */
function rightButton(id) {
    if (event.button == 2) {
       execMouseDown(event, true, id);
    }
}
/**
 * 执行客户端命令,获取参数
 * @param  {string} order 命令名称
 * @param  {string} param 参数
 * @return {void|object}       无|-
 */
function execSync(order, param) {
    try {
        if (window.external.SyncRequest) {
            return window.external.SyncRequest(order, param);
        } 
    } catch (e) {
        return '';
    }
    return '';
}
/**
 * 动作关键词
 * @param {string} keyword 动作关键词(用来映射动画,默认为nomal)
 */
function setAnimation(keyword) {
    var actionName = rabbit.animationMap[keyword] || keyword; //原为中文映射皮肤
    skin.animation(actionName, 'action'); 
}
var skin = window.skin || {};
/**
 * 绑定输入法icon点击/hover等事件
 * @return {void} 无
 */
skin.bindEvent = function () {
    var icons = g('iconEvent').getElementsByTagName('div');
    for (var i = 0, len = icons.length; i < len; i++) {        
        icons[i].onclick = function () { 
            execMouseDown(event, false, this.getAttribute('key'));
        }
        icons[i].onmouseup = function () { 
            rightButton(this.getAttribute('key'));
        }
        icons[i].onmouseover = function () { 
            execOrder('mouseOver', this.getAttribute('key'));
        }
        icons[i].onmouseout = function () { 
        execOrder('mouseOver', 'null');
        }
    }
    document.onclick  =function () {
        execMouseDown(event, false, 'null');    
    }
    
    document.onmouseup =function () {  
        rightButton('null'); 
    }
},
/**
 * 设置动画 
 * @param  {string} actionName 动画名称
 * @return {void}            无
 */
skin.animation = function (actionName, element, test) {  
    if (skin.animateName != "nomal" ) { 
        return;
    }
    actionName = actionName || 'nomal';
    skin.animateName = actionName;  

    var parent = g(element);
    skin.actionNode = parent;
    var action = rabbit.animations[actionName];
    parent.innerHTML = '';   

    var actionDom = createElement('div', action.className);
    parent.appendChild(actionDom);
    // 子节点
    if (action['childNode'] && action['childNode'].length > 0) {
        var child = null;
        for (var i = 0, len = action['childNode'].length; i < len; i++) {
            child = createElement('div', action.childNode[i]);
            actionDom.appendChild(child);
        }
    }    
    // 增加动画转变
    if (action['delay']) {
        var delay = action['delay']; 
        if (skin.timer) {
            clearTimeout(skin.timer);
        }
        skin.timer = window.setTimeout(function () {        
            addClass(skin.actionNode.getElementsByTagName('div')[delay.num], delay.className);  
            
            if (action.duration > 0) {
                skin.cancelAnimate(action.duration * 2);
            }            
        }, delay.time);           
        
    } else {
        if (action.duration > 0) {
            skin.cancelAnimate(action.duration);
        }   
    }      
};
/**
 * 清空兔子特效
 * @param  {number} duration 特效执行时间
 * @return {void}          无
 */
skin.cancelAnimate = function (duration) { 
    window.clearTimeout(skin.cancelTimer);
    skin.cancelTimer = window.setTimeout(function () {  
        skin.animateName = 'nomal';       
        skin.animation('nomal', 'action');                
    }, duration); 
};
/**
 * 追加子元素
 * @param  {object} list    子元素样式
 * @param  {string} tagName 元素名称
 * @param  {object} parent  父元素对象
 * @return {void}         无
 */
skin.appendChildList = function (list, tagName, parent) {
    var element = null;
    for (var i =0, len = list.length; i < len; i++) {
        element = createElement(tagName, list[i]);
        parent.appendChild(element);
    }
}
